      INTEGER    NMAX
      PARAMETER (NMAX =  11289600)
C
      INTEGER    FLAGFILE,FLAHOUT,I,N,J,NAV,N1,N2
      INTEGER    IDUMMY
      INTEGER    FLAGPR
C
      REAL       VX(NMAX),VY(NMAX),VZ(NMAX),PR(NMAX),P(NMAX),Q(NMAX)
      REAL       HOUR(NMAX),TEMP(NMAX),O2SATDEN(NMAX),O2(NMAX)
      REAL       VOLT1,VOLT2
      REAL       HOURSTART
      REAL       HZ,HZOUT
      REAL       SAL,Z,ATMPR,FACTOR
      REAL       PROFFSET
      REAL       AT,BT,CT,DT
      REAL       AO2,BO2,CO2,DO2,EO2,FO2,GO2,HO2
      REAL       DUMMY
      REAL       O2FACTOR1,O2FACTOR2,O2FACTOR3,TIME1,TIME2,TIME3
      REAL       O2FACTOR4,O2FACTOR5,O24,O25
C
      CHARACTER  FILENAME*20
C
      REAL       MEAN,O2SAT,DENSITY,ELEVATIONCORR1,ELEVATIONCORR2,O2RINKO,TEMPRINKO
C
C
C
      WRITE(6,'(A80)') ' ----------------- Welcome to ExtractRINKO  Version 1.6 Open -------------------'
C
      FLAGFILE = -1
 	DO WHILE(FLAGFILE .NE. 0)
        WRITE(6,'(/,A26,\)') ' Name of definition file: '
        READ(5,'(A20)') FILENAME
        OPEN(UNIT = 1,STATUS = 'OLD',IOSTAT = FLAGFILE,FILE = FILENAME)
 	  IF(FLAGFILE .NE. 0) WRITE(6,'(A45)') ' This file does not exist - please try again.'
 	END DO
C
      WRITE(6,'(/,A13)') ' READING DATA'
C
      READ(1,*,ERR =990) FILENAME
      READ(1,*,ERR =990) FILENAME
      OPEN(UNIT = 2,STATUS = 'OLD',IOSTAT = FLAGFILE,FILE = FILENAME)
	IF(FLAGFILE .NE. 0) GOTO 991 
C
      READ(1,*,ERR =990)   FILENAME						
      OPEN(UNIT = 3,FILE = FILENAME)
C
      READ(1,*,ERR =990) HOURSTART					
      READ(1,*,ERR =990) HZ					
      READ(1,*,ERR =990) HZOUT
      READ(1,*,ERR =990) PROFFSET
      READ(1,*,ERR =990) SAL
      READ(1,*,ERR =990) FLAGPR
      READ(1,*,ERR =990) Z
      READ(1,*,ERR =990) ATMPR
      READ(1,*,ERR =990) AT					
      READ(1,*,ERR =990) BT					
      READ(1,*,ERR =990) CT					
      READ(1,*,ERR =990) DT					
      READ(1,*,ERR =990) AO2					
      READ(1,*,ERR =990) BO2					
      READ(1,*,ERR =990) CO2					
      READ(1,*,ERR =990) DO2					
      READ(1,*,ERR =990) EO2					
      READ(1,*,ERR =990) FO2					
      READ(1,*,ERR =990) GO2					
      READ(1,*,ERR =990) HO2					
      READ(1,*,ERR =990) FLAHOUT					
      READ(1,*,ERR =990) TIME1					
      READ(1,*,ERR =990) TIME2					
      READ(1,*,ERR =990) TIME3
      READ(1,*,ERR =990) O2FACTOR1					
      READ(1,*,ERR =990) O2FACTOR2											
      READ(1,*,ERR =990) O2FACTOR3
      READ(1,*,ERR =990) O24					
      READ(1,*,ERR =990) O25					
      READ(1,*,ERR =990) O2FACTOR4					
      READ(1,*,ERR =990) O2FACTOR5											
C
      IF(FLAHOUT .EQ. 0) WRITE(3,'(A60)') '      hour        vx        vy        vz         P         Q'
      IF(FLAHOUT .EQ. 1) WRITE(3,'(A60)') '      hour        vx        vy        vz      temp     O2sat'
      IF(FLAHOUT .EQ. 2) WRITE(3,'(A60)') '      hour        vx        vy        vz      temp      pres'
      IF(FLAHOUT .EQ. 3) WRITE(3,'(A60)') '      hour        vx        vy        vz        O2      pres'
      IF(FLAHOUT .EQ. 4) WRITE(3,'(A60)') '      hour        vx        vy        vz      temp        O2'
      IF(FLAHOUT .EQ. 5) WRITE(3,'(A60)') '      hour        vx        vy        vz        O2      temp'
      IF(FLAHOUT .EQ. 6) WRITE(3,'(A60)') '      hour        vx        vy        vz        O2     O2sat'
C
C
C
      WRITE(6,'(/,A13)') ' Reading data'
C
      I = 0
   30 CONTINUE
        I = I+1
        IF(I .GT. NMAX) GOTO 992
	  READ(2,*,END = 40) IDUMMY,IDUMMY,VX(I),VY(I),VZ(I),IDUMMY,IDUMMY,IDUMMY,DUMMY,DUMMY,DUMMY,IDUMMY,IDUMMY,IDUMMY,
     +                                     PR(I),P(I),Q(I)
	GOTO 30
   40 CONTINUE
      N = I-1
      WRITE(6,'(/,A22,I8,/)') ' Number of data read: ',N
C
      IF(FLAGPR .EQ. 0) FACTOR = ELEVATIONCORR1(Z)
      IF(FLAGPR .EQ. 1) FACTOR = ELEVATIONCORR2(ATMPR)
C
      DO I = 1,N
        HOUR(I)     = HOURSTART+((1.0/HZ)*FLOAT(I))/3600.0
        VX(I)       = VX(I)*100.0
        VY(I)       = VY(I)*100.0
        VZ(I)       = VZ(I)*100.0
        PR(I)       = PR(I)*100.0-PROFFSET
C
        VOLT1       = 5.0*P(I)/65535.0
        VOLT2       = 5.0*Q(I)/65535.0
        TEMP(I)     = TEMPRINKO(AT,BT,CT,DT,VOLT2)
        O2SATDEN(I) = O2SAT(TEMP(I),SAL)*DENSITY(TEMP(I),SAL)*FACTOR
        O2(I)       = O2RINKO(AO2,BO2,CO2,DO2,FO2,GO2,HO2,TEMP(I),VOLT1,O2SATDEN(I))
C
        IF(HOUR(I) .LE. TIME2) O2(I) = O2(I)*(O2FACTOR1+(HOUR(I)-TIME1)*(O2FACTOR2-O2FACTOR1)/(TIME2-TIME1))
        IF(HOUR(I) .GT. TIME2) O2(I) = O2(I)*(O2FACTOR2+(HOUR(I)-TIME2)*(O2FACTOR3-O2FACTOR2)/(TIME3-TIME2))
C
        O2(I) = O2(I)*(O2FACTOR4+(O2(I)-O24)*(O2FACTOR5-O2FACTOR4)/(O25-O24))
      END DO
C
      NAV = INT(HZ/HZOUT+0.5)
C
	DO J = 1,INT(FLOAT(N)/FLOAT(NAV)+0.5)-1
	  N1 = 1+NAV*(J-1)
        N2 = N1+NAV-1
C
        IF(FLAHOUT .EQ. 0) WRITE(3,'(F10.6,3F10.3,F10.1,F10.1)')
     +    MEAN(N1,N2,HOUR),MEAN(N1,N2,VX),MEAN(N1,N2,VY),MEAN(N1,N2,VZ),MEAN(N1,N2,P),MEAN(N1,N2,Q)
C
        IF(FLAHOUT .EQ. 1) WRITE(3,'(F10.6,3F10.3,F10.4,F10.3)')
     +    MEAN(N1,N2,HOUR),MEAN(N1,N2,VX),MEAN(N1,N2,VY),MEAN(N1,N2,VZ),MEAN(N1,N2,TEMP),MEAN(N1,N2,O2SATDEN)
C
        IF(FLAHOUT .EQ. 2) WRITE(3,'(F10.6,3F10.3,F10.4,F10.2)')
     +    MEAN(N1,N2,HOUR),MEAN(N1,N2,VX),MEAN(N1,N2,VY),MEAN(N1,N2,VZ),MEAN(N1,N2,TEMP),MEAN(N1,N2,PR)
C
        IF(FLAHOUT .EQ. 3) WRITE(3,'(F10.6,3F10.3,F10.3,F10.2)')
     +    MEAN(N1,N2,HOUR),MEAN(N1,N2,VX),MEAN(N1,N2,VY),MEAN(N1,N2,VZ),MEAN(N1,N2,O2),MEAN(N1,N2,PR)
C
        IF(FLAHOUT .EQ. 4) WRITE(3,'(F10.6,3F10.3,F10.4,F10.3)') 
     +    MEAN(N1,N2,HOUR),MEAN(N1,N2,VX),MEAN(N1,N2,VY),MEAN(N1,N2,VZ),MEAN(N1,N2,TEMP),MEAN(N1,N2,O2)
C
        IF(FLAHOUT .EQ. 5) WRITE(3,'(F10.6,3F10.3,F10.3,F10.4)') 
     +    MEAN(N1,N2,HOUR),MEAN(N1,N2,VX),MEAN(N1,N2,VY),MEAN(N1,N2,VZ),MEAN(N1,N2,O2),MEAN(N1,N2,TEMP)
C
        IF(FLAHOUT .EQ. 6) WRITE(3,'(F10.6,3F10.3,F10.3,F10.3)') 
     +    MEAN(N1,N2,HOUR),MEAN(N1,N2,VX),MEAN(N1,N2,VY),MEAN(N1,N2,VZ),MEAN(N1,N2,O2),MEAN(N1,N2,O2SATDEN)
      END DO
C
C
C
      CLOSE(UNIT = 1)
      CLOSE(UNIT = 2)
      PAUSE 'Press ENTER to close DOS window'
      STOP
C       
  990 CONTINUE
      CLOSE(UNIT = 1)
      CLOSE(UNIT = 2)
      CLOSE(UNIT = 3)
      PAUSE 'Error: Definition file has the wrong format - press ENTER' 		
	STOP
C       
  991 CONTINUE
      CLOSE(UNIT = 1)
      CLOSE(UNIT = 2)
      CLOSE(UNIT = 3)
      PAUSE 'Error: Input file does not exist - press ENTER' 		
	STOP
C
  992 CONTINUE
      CLOSE(UNIT = 1)
      CLOSE(UNIT = 2)
      PAUSE 'Error: Too many data - press ENTER' 		
	STOP
C       
      END
C
C
C
      REAL FUNCTION MEAN(N1,N2,Y)
C
      INTEGER    NMAX
      PARAMETER (NMAX =  11289600)
C
      INTEGER    N1,N2,I
      REAL       Y(NMAX)
C
      MEAN = 0.0
      DO I = N1,N2
	  MEAN = MEAN+Y(I)
	END DO
	MEAN = MEAN/FLOAT(N2-N1+1)
C
      RETURN
	END
C
C
C
      REAL FUNCTION O2SAT(TEMP,SAL)
C
      REAL       TEMP,SAL,A0,A1,A2,A3,A4,A5,B0,B1,B2,B3,C0,TS
C
C     From:  Garcia and Gordon (1992) Oxygen Solubility in Seawater: Better Fitting Equations, L&O
C            Output O2 saturation conecntration in [mymol kg-1]
C
      A0 =  5.80818
      A1 =  3.20684
      A2 =  4.11890
      A3 =  4.93845
      A4 =  1.01567
      A5 =  1.41567
      B0 = -7.01211E-03
      B1 = -7.25958E-03
      B2 = -7.93334E-03
      B3 = -5.54491E-03
      C0 = -1.32412E-07
C
      TS = LOG((298.15-TEMP)/(273.15+TEMP))
      O2SAT = EXP(A0+A1*TS+A2*TS**2+A3*TS**3+A4*TS**4+A5*TS**5+SAL*(	
     +            B0+B1*TS+B2*TS**2+B3*TS**3)+C0*SAL**2)
C
      RETURN
	END
C
C
C
      REAL FUNCTION DENSITY(TEMP,SAL)
C
      REAL       TEMP,SAL,DENSITY0,A,B,C
C
C     From:  Standard Methods for the Examination of Water and Wastewater
C            Output density of seawater in [g cm-3]
C
      A =           8.24493E-01-4.0899E-03*TEMP+7.6438E-05*TEMP**2-8.2467E-07*TEMP**3+5.3875E-09*TEMP**4
      B =          -5.72466E-03+1.0227E-04*TEMP-1.6546E-06*TEMP**2
      C =           4.83140E-04
      DENSITY0 =  999.842594+6.793952E-02*TEMP-9.095290E-03*TEMP**2+1.001685E-04*TEMP**3-1.120083E-06*TEMP**4+6.536332E-09*TEMP**5
C
      DENSITY = DENSITY0+A*SAL+B*SAL**1.5+C*SAL**2
      DENSITY = DENSITY/1000.0
C
      RETURN
	END
C
C
C
      REAL FUNCTION O2RINKO(AO2,BO2,CO2,DO2,FO2,GO2,HO2,TEMP,VOLT,O2SATDEN)
C
      REAL       AO2,BO2,CO2,DO2,FO2,GO2,HO2,TEMP,VOLT,O2SATDEN,O2PCT
C
      O2PCT = GO2+HO2*(AO2/(      1.0+DO2*(TEMP-25.0)+FO2*(TEMP-25.0)**2)+
     +                 BO2/(VOLT*(1.0+DO2*(TEMP-25.0)+FO2*(TEMP-25.0)**2)+CO2))
C
      O2RINKO = O2PCT*O2SATDEN/100.0
C
      RETURN
	END
C
C
C
      REAL FUNCTION TEMPRINKO(AT,BT,CT,DT,VOLT)
C
      REAL       AT,BT,CT,DT,VOLT
C
      TEMPRINKO = AT+BT*VOLT+CT*VOLT**2+DT*VOLT**3	
C
      RETURN
	END
C
C
C
      REAL FUNCTION ELEVATIONCORR1(Z)
C
      REAL       Z
C
      ELEVATIONCORR1 = (1013.25-Z*0.11568)/1013.25 
C
      RETURN
	END
C
C
C
      REAL FUNCTION ELEVATIONCORR2(ATMPR)					 
C
      REAL       ATMPR
C
      ELEVATIONCORR2 = ATMPR/1013.25	
C
      RETURN
	END




